#include <iostream>
#include <cmath>
#include <cstdio>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <queue>
#include <vector>
#include <stack>
#define MAXNUM 10000003
using namespace std;
typedef long long ll;
bool prime[MAXNUM];
multiset <ll> s;
pair <ll, ll> tree[8*MAXNUM];
void eratosten()
{
    memset(prime, true, sizeof(prime));
    prime[1] = prime[0] = false;
    for (int i = 2; i < MAXNUM; i++)
        if (prime[i])
        for (int j = i * 2; j < MAXNUM; j += i)
        prime[j] = false;
}
void update(ll v, ll l, ll r, ll num)
{
    if (num < l || num > r) return;
    if (l == r)
    {
        tree[v].first += num;
        tree[v].second++;
        return;
    }
    update(v*2, l, (l + r) / 2, num);
    update(v*2+1, (l + r) / 2 + 1, r, num);
    tree[v].first = tree[v*2].first + tree[v*2+1].first;
    tree[v].second = tree[v*2].second + tree[v*2+1].second;
}
void update1(ll v, ll l, ll r, ll num)
{
    if (num < l || num > r) return;
    if (l == r)
    {
        tree[v].first -= num;
        tree[v].second--;
        return;
    }
    update1(v*2, l, (l + r) / 2, num);
    update1(v*2+1, (l + r) / 2 + 1, r, num);
    tree[v].first = tree[v*2].first + tree[v*2+1].first;
    tree[v].second = tree[v*2].second + tree[v*2+1].second;
}
ll get1(ll v, ll l, ll r, ll x, ll y)
{
    if (r < x || l > y) return 0;
    if (l >= x && r <= y) return tree[v].first;
    return get1(v*2, l, (l+r)/2, x, y) + get1(v*2+1, (l+r)/2+1, r, x, y);
}
ll get2(ll v, ll l, ll r, ll x, ll y)
{
    if (r < x || l > y) return 0;
    if (l >= x && r <= y) return tree[v].second;
    return get2(v*2, l, (l+r)/2, x, y)+ get2(v*2+1, (l+r)/2+1, r, x, y);
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    eratosten();
    char sy;
    while (cin >> sy)
    {
        if (sy == 'a')
        {
            ll num;
            cin >> num;
            if (prime[num])
            {
                s.insert(num);
                update(1, 1, MAXNUM, num);
            }
        }
        else if (sy == 'd')
        {
            ll num;
            cin >> num;
            auto it = s.find(num);
            if (it != s.end())
                {
                    s.erase(it);
                    update1(1, 1, MAXNUM, num);
                }
        }
        else
        {
            ll l, r;
            cin >> l >> r;
            cout << get2(1, 1, MAXNUM, l, r) << " " << get1(1, 1, MAXNUM, l, r) << endl;
        }
    }
}
/*
a 1
a 5
c 5 5
a 4
c 1 50
a 3
d 5
a 7
a 6
a 7
c 3 8
a 10
a 11
a 12
c 8 12
d 11
c 7 11
d 7
d 7
d 7
c 1 100
c 100 200
*/
