#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> inline void chkmax(T &x, const T1 &y) { if (x < y) x = y; }
template<class T, class T1> inline void chkmin(T &x, const T1 &y) { if (x > y) x = y; }
typedef long long ll;

const int MAX_ELEMENTS = (int)1e5;

int N, M;
int A[MAX_ELEMENTS + 5], B[MAX_ELEMENTS + 5];

void read()
{
    cin >> N >> M;
    for (int i = 0; i < N; i++)
        cin >> A[i];
    for (int i = 0; i < M; i++)
        cin >> B[i];
}

ll s1[MAX_ELEMENTS + 5], s2[MAX_ELEMENTS + 5];

void calc()
{
    s1[0] = (ll)A[0];
    s2[0] = (ll)B[0];
    for (int i = 1; i < N; i++)\
        s1[i] = s1[i - 1] + (ll)A[i];
    for (int i = 1; i < M; i++)
        s2[i] = s2[i - 1] + (ll)B[i];
}

bool vis[MAX_ELEMENTS + 5];

void mark(int x, int y)
{
    for (int i = x; i <= y; i++)
        vis[A[i]] = true;
}

void unmark(int x, int y)
{
    for (int i = x; i <= y; i++)
        vis[A[i]] = false;
}

bool is_ok(int x, int y)
{
    for (int i = x; i <= y; i++)
        if (vis[B[i]])
            return false;
    return true;
}

void solve_slow()
{
    memset(vis, false, sizeof(vis));
    calc();
    int m_i1, m_j1, m_i2, m_j2;
    ll max_sum = 0ll;
    for (int i1 = 0; i1 < N; i1++)
    {
        for (int j1 = i1 + 1; j1 < N; j1++)
        {
            mark(i1, j1);
            ll sum1 = s1[j1] - s1[i1] + (ll)A[i1];
            for (int i2 = 0; i2 < M; i2++)
            {
                if (vis[B[i2]])
                    continue;
                int l = j1 - i1 + 1;
                int to = i2 + l - 1;
                if (is_ok(i2, to))
                {
                    ll sum2 = s2[to] - s2[i2] + (ll)B[i2];
                 //   cout << i1 << ' ' << j1 << " - " << i2 << ' ' << to << " - " << sum1 + sum2 << endl;
                    ll curr_sum = sum1 + sum2;
                    if (curr_sum > max_sum)
                    {
                        max_sum = curr_sum;
                        m_i1 = i1 + 1;
                        m_j1 = j1 + 1;
                        m_i2 = i2 + 1;
                        m_j2 = to + 1;
                    }
                }

            }
            unmark(i1, j1);
        }
    }
    cout << max_sum << endl;
    if (max_sum > 0)
        cout << m_i1 << ' ' << m_j1 << endl << m_i2 << ' ' << m_j2 << endl;
}

void solve()
{
    solve_slow();
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    read();
    solve();

    return EXIT_SUCCESS;
}
